rawset(_G, "P_IsPlayerDream", function(player)
	local skin = player.mo.skin
	if skin == "sonic"
	or skin == "tails"
	or skin == "knuckles"
	or skin == "amy"
	or skin == "fang"
	or skin == "metalsonic"
		return true
	else
		return false
	end
end)

addHook("PlayerThink", function(player)
	if not P_IsPlayerDream(player) return end
	if (player.speed >= skins[player.mo.skin].runspeed or player.mo.standingslope)
	and (player.cmd.forwardmove or player.cmd.sidemove)
		player.mo.friction = FRACUNIT
		player.charflags = $ & ~SF_NOSKID
	elseif (player.speed >= skins[player.mo.skin].runspeed or player.mo.standingslope)
	and not (player.cmd.forwardmove and player.cmd.sidemove)
		player.mo.friction = 100*FRACUNIT/101
		player.charflags = $|SF_NOSKID
	else
		player.mo.friction = 29*FRACUNIT/32
		player.charflags = $ & ~SF_NOSKID
	end
	if player.speed >= 50*FRACUNIT
	and not player.boostmode
		player.boostmode = true
		S_StartSound(player.mo, sfx_zoom)
	elseif player.speed < 50*FRACUNIT
	and P_IsObjectOnGround(player.mo)
	and player.boostmode
		player.boostmode = false
	end
	if player.boostmode
		player.charflags = $1|SF_RUNONWATER
    else
       player.charflags = $1 & ~SF_RUNONWATER
	end
	if player.boostmode
		if P_IsObjectOnGround(player.mo)
			P_SpawnSkidDust(player, player.speed/4)
		end
		P_Thrust(player.mo, player.mo.angle, FRACUNIT/10)
		if leveltime%5 == 0
			SpawnGhost(player)
		end
		if leveltime%25 == 0
			S_StartSound(player.mo, sfx_zoom)
		end
	end
	if not (player.cmd.buttons & BT_USE)
		player.pressedspin = false
	end
	if player.boostmode
		player.powers[pw_strong] = $|STR_SPIKE|STR_WALL
	else
		player.powers[pw_strong] = STR_NONE
	end
	if player.truedrawangle == nil
		player.truedrawangle = player.drawangle
	end
	if player.cmd.forwardmove 
	or player.cmd.sidemove
		player.truedrawangle = player.drawangle
	end
	if not P_IsObjectOnGround(player.mo)
		player.truedrawangle = player.drawangle
	end
	if not (player.cmd.forwardmove and player.cmd.sidemove)
	and P_IsObjectOnGround(player.mo)
		player.drawangle = player.truedrawangle
	end
	if player.sprung == nil
		player.sprung = false
	end
	if P_IsPlayerOnGround(player)
	and not (player.mo.eflags & MFE_SPRUNG)
		player.sprung = false
	elseif (player.mo.eflags & MFE_SPRUNG)
	and not P_IsPlayerOnGround(player)
		player.sprung = true
	end
	if player.mo.momz == 0
	and player.sprung
		player.mo.state = S_PLAY_WALK
	end
	if player.speed >= skins[player.mo.skin].runspeed*2
		player.camerascale = $ + FRACUNIT/100
	elseif player.speed < skins[player.mo.skin].runspeed*2
	and player.camerascale > FRACUNIT
		player.camerascale = $ - FRACUNIT/10
	end
end)

addHook("PlayerSpawn", function(player)
	if P_IsPlayerDream(player)
		player.truedrawangle = player.drawangle
	end
end)

addHook("SpinSpecial", function(player)
	if not P_IsPlayerDream(player) return end
	if player.pressedspin return end
	if not (player.pflags & PF_SPINNING)
	and ((player.mo.eflags & MFE_JUSTHITFLOOR) or P_IsObjectOnGround(player.mo))
	and player.speed > 0*FRACUNIT
		player.pflags = $|PF_SPINNING
		player.mo.state = S_PLAY_ROLL
		player.pressedspin = true
		return true
	elseif (player.pflags & PF_SPINNING)
	and player.speed >= skins[player.mo.skin].runspeed
		player.pflags = $ & ~PF_SPINNING
		player.mo.state = S_PLAY_RUN
		player.pressedspin = true
		return true
	elseif (player.pflags & PF_SPINNING)
	and not P_IsObjectOnGround(player.mo)
		player.pflags = $ & ~PF_SPINNING
		player.mo.state = S_PLAY_FALL
		player.pressedspin = true
		return true
	elseif not P_IsObjectOnGround(player.mo)
		player.pflags = $|PF_JUMPED
		player.mo.state = S_PLAY_ROLL
		player.pressedspin = true
		return true
	else
		return false
	end
end)

addHook("PlayerSpawn", function(player)
	if not P_IsPlayerDream(player) return end
	player.pressedspin = false
	player.dropdash = false
	player.boostmode = false
	player.dropdashspeed = 0
	player.fly = 0
	player.flyheight = 0
	player.flyuse = 0
end)

rawset(_G, "P_IsPlayerOnGround", function(player)
	if ((player.mo.eflags & MFE_JUSTHITFLOOR) or P_IsObjectOnGround(player.mo))
		return true
	else
		return false
	end
end)


addHook("PlayerCanDamage", function(player)
	if player.boostmode
		return true
	end
end)